# This file is taken from http://antrix.net/stuff/writr/ project. Provides a very nice and useful 
# way to parse HTML for good visual display.
# Licensed under GNU GPL. 

import traceback
import gtkhtml2
from markdown import markdown

class HtmlView(gtkhtml2.View):
    
    def __init__(self):
        gtkhtml2.View.__init__(self)
        self.document = gtkhtml2.Document()
        self.set_document(self.document)

    def update(self, text, parent):
        self.document.open_stream(u'text/html')
        self.document.write_stream(u"""<html><head>
            <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
            <title>Try</title>
            </head>
            <body bgcolor="#CCCCFF">""")
        try:
            fmt_text = markdown(text.encode("utf-8"))
            self.document.write_stream(fmt_text)
            self.document.write_stream(u"</body></html>")
            self.document.close_stream()
        except:
            traceback.print_exc()
            fmt_text =  "<h3>Markdown conversion failed!</h3>" \
                     +  "The following error was encountered:<br/><br/>" 
            tb_str   =  traceback.format_exc()
            fmt_text += "<code><pre>%s</pre></code>" % tb_str
            self.document.write_stream(fmt_text)
            self.document.write_stream(u"</body></html>")
            self.document.close_stream()
